/* Libero COMSCORE Version 1.45 */
if ( typeof(Libero) == 'undefined' ) {
	Libero = {};
}

if ( typeof(Libero.Stash) == 'undefined' ) {
	Libero.Stash = {};
}

if ( typeof(Prototype) == 'undefined' ) {
	var Class = {
		create: function() {
			return function() {
				this.initialize.apply(this, arguments);
			};
		}
	};
	Object.extend = function(destination, source) {
		for (var property in source) {
			destination[property] = source[property];
		}
		return destination;
	};
}

try { Libero.Stash.csDebug = libero_comscore_debug } catch (e) {}
try { Libero.Stash.csTest = libero_comscore_test } catch (e) {}
try { Libero.Stash.csCNAutoComplete = libero_comscore_cnautocomplete } catch (e) {}
try { Libero.Stash.csCheckMultipleCalls = libero_comscore_check_multiple_calls } catch (e) {}

if ( /\.(st|pp)\.libero\.it$/.test(document.location.host) ) {
	Libero.Stash.csTest = 1;
	Libero.Stash.csDebug = 1;
}

if ( /Libero(Tracking|Comscore)Debug=(\d+)/.test(document.cookie) ) {
	Libero.Stash.csDebug = RegExp.$2;
}

if ( typeof console == 'undefined' ) {
	Libero.Stash.csDebug = 0;
}

if ( Libero.Stash.csDebug )
	console.log('[LT]', 'Starting (1.45) engine');

if ( typeof Libero.Stash.csImages != 'number' ) 
	Libero.Stash.csImages = 0;

Libero.getTracking = function () {
	var args = Object.extend({
		csObj: Libero.Stash.csObj,
		ajax: undefined,
		url: document.location.href,
		path: document.location.pathname,
		cookie: document.cookie,
		search: document.location.search,
		referrer: document.referrer,		
		debug: Libero.Stash.csDebug,
		test: Libero.Stash.csTest,
		callDirectly: 0,
		callJS: 0,
		https: document.location.protocol == 'https:', 
		log_prefix: '[LT]',
		check_multiple_calls: Libero.Stash.csCheckMultipleCalls,
		add_host_to_cn: Libero.Stash.csCNAutoComplete,
		onLoadHandler: undefined,
		labels: Libero.Stash.csLabels,
		timeout: 2,
		trackingUrl: undefined,
		cacheCountername: false
	}, arguments[0]);

	
	if ( typeof console == 'undefined' ) {
		args.debug = 0;
	}

	if ( args.debug )
		console.log(args.log_prefix, 'getTracking', args);

	var countername;

	if ( args.cacheCountername ) {
		countername = Libero.Stash.csName;
		if ( args.debug )
			console.log(args.log_prefix, 'Getting cn from cache: ', countername);
	}	
	else {

		countername = args.csObj.defaultCn;
	
		for ( var i = 0, l = args.csObj.cn.length; i < l; i++ ) {
	
			var found = 0;
	
			if ( args.debug )
				console.log(args.log_prefix, args.csObj.cn[i].n, args.csObj.cn[i]);
	
			var re;
			try {
				re = new RegExp(args.csObj.cn[i].v);
			}
			catch (e) {
				if (args.debug)
					console.log(args.log_prefix, e);
				continue;		
			}
			
			if ( args.debug )
				console.log(args.log_prefix, 'Matching ' + args.csObj.cn[i].t + ' ' + args.csObj.cn[i].v);
	
			var value; 
	
			if ( args.csObj.cn[i].t == 'js' ) {
				try {
					eval('value = ' + args.csObj.cn[i].id);
				}
				catch (e) {
					if (args.debug)
						console.log(args.log_prefix, e);
					continue;
				}
			}
			else if ( args.csObj.cn[i].t == 'dom' ) {
				try {
					value = document.getElementById(args.csObj.cn[i].id).innerHTML;
				}
				catch (e) {
					if (args.debug)
						console.log(args.log_prefix, e);
					continue;
				}
			}
			else {	
				value = args[args.csObj.cn[i].t];
			}
			
			if ( value == null || /^\s*$/.test(value) ) {
				if (args.debug)
					console.log(args.log_prefix, 'Skipped null value');
				continue;
			}
	
			if ( re.test(value) ) {
				if ( args.debug ) 
					console.log(args.log_prefix, 'FOUND (' + args[args.csObj.cn[i].t] + ' =~ ' + re + ')');
				found = 1;
				countername = args.csObj.cn[i].n;
				break;
			}
		}
	
		if ( args.add_host_to_cn ) {
			countername += '.' + document.location.hostname.replace(/\./g,'_');
		}
	} // End geting countername
	
	if ( ( args.callJS && typeof COMSCORE != 'undefined' ) || args.callDirectly ) {

		Libero.Stash.csImages++;

		if ( typeof args.check_multiple_calls == 'number' && args.check_multiple_calls > 0 && Libero.Stash.csImages > args.check_multiple_calls ) {
			if ( args.debug )
				console.log(args.log_prefix, 'Tracking skipped, the calls (' + Libero.Stash.csImages + ') reached max limit (' + args.check_multiple_calls + ')');
		}
		else if ( args.callDirectly ) {
			var i = new Image(), 
				esc = typeof(encodeURIComponent) == 'function' ? encodeURIComponent : escape, 
				label_qs = '';
			if ( typeof(args.labels) == 'object' ) {
				for ( var prop in args.labels ) {
					if ( typeof(args.labels[prop]) == 'undefined' )
						continue;
					label_qs += '&' + prop + '=' + esc(args.labels[prop]);
				}
			}
			
			if ( typeof(args.onLoadHandler) == 'function' ) {
				if ( args.debug )
					console.log(args.log_prefix, 'Adding onload handler: ', args.onLoadHandler);
				
				var tracking_timeout = window.setTimeout("Libero.Stash.csOnLoad()", args.timeout*1000);
				
				Libero.Stash.csOnLoad = function () {
					try { window.clearTimeout(tracking_timeout) } catch (e) {}

					i.onload = i.onerror = function () {return};
					
					args.onLoadHandler();
				};
				i.onload = Libero.Stash.csOnLoad;
				i.onerror = Libero.Stash.csOnLoad;
			}
			
			if ( typeof(args.trackingUrl) != 'undefined' && typeof(args.trackingUrl) == 'string' )
				i.src = args.trackingUrl + '&_t=' + +(new Date); 
			else
				i.src = (args.https ? 'https://sb' : 'http://b') + '.scorecardresearch.com/b?c1=2&c2=13259779&cj=1&name=' + esc(countername) + '&ns_site=' + ( args.test ? 'test' : 'libero' ) + '&c7=' + esc(args.url) + '&c9=' + esc(args.ajax || args.referrer) + '&ns__t=' + +(new Date) + label_qs;
			if ( args.debug )
				console.log(args.log_prefix, 'Making direct call to ', i);
		}
		else {
			if ( args.debug )
				console.log(args.log_prefix, 'Making standard call...');
			COMSCORE.beacon(
				Object.extend(
					{
						c1: 2,
						c2: 13259779,
						name: countername,
						ns_site: args.test ? 'test' : 'libero'
					},
					typeof(args.labels) == 'object' ? args.labels : {}
				) 
			);
		}
	}

	if ( args.debug )
		console.log(args.log_prefix, 'The winner is: ' + countername);
	return countername;
}
Libero.getComscore = Libero.getTracking;

Libero.click = function () {

	var on_load_handler;
	var argument_idx = 0;
	var href;

	if ( typeof(arguments[0]) == 'object' && arguments[0].tagName == 'A' ) { 
		href = arguments[0].href;
		if ( typeof(href) == 'string' ) {
			on_load_handler = function () {
				document.location.href = href;
			};
			argument_idx = 1;
		}
	}
	else {
		argument_idx = 0;
	}

	var args = Object.extend({
		callDirectly: 1,
		cacheCountername: 1,
		onLoadHandler: on_load_handler
	}, arguments[argument_idx]); 

	args.labels = Object.extend(args.labels || {}, {
		ns_type: 'hidden',
		lib_name: Libero.Stash.csName,
		lib_ev_type: 'click',
		lib_dest: href
	});

	return Libero.getTracking(args);
}

Libero.Stash.csObj = {
   "defaultCn" : "libero.news.24x7.others",
   "cn" : [
      {
         "n" : "errors.libero",
         "v" : "^(4|5)\\d\\d$",
         "id" : "libero_comscore_error",
         "t" : "js"
      },
      {
         "n" : "libero.news.24x7.homepage",
         "v" : "^(\\/+|\\/+index\\.html)?$",
         "t" : "path"
      },
      {
         "n" : "libero.news.24x7.timeline",
         "v" : "^\\/+timeline\\.html",
         "t" : "path"
      },
      {
         "n" : "libero.news.24x7.grafo",
         "v" : "^\\/+graph\\/?",
         "t" : "path"
      },
      {
         "n" : "libero.news.24x7.regionali",
         "v" : "^\\/+regionali\\/?",
         "t" : "path"
      },
      {
         "n" : "libero.news.24x7.dsearch",
         "v" : "^\\/+dsearch\\/?",
         "t" : "path"
      },
      {
         "n" : "libero.news.24x7.search",
         "v" : "^\\/+search\\/?",
         "t" : "path"
      },
      {
         "n" : "libero.news.24x7.focus",
         "v" : "^\\/+focus\\/?",
         "t" : "path"
      },
      {
         "n" : "libero.news.24x7.mfocus",
         "v" : "^\\/+mfocus\\/?",
         "t" : "path"
      }
   ]
};

Libero.CGI = function (url) {
	var query_string;
	if ( typeof(url) == 'undefined' || typeof(url) != 'string' )
		return {};
	query_string = url.split(/\?/)[1];
	if ( query_string ) {
		this.search = query_string;
		var pairs = this.search.split(/\&+/);
		for ( var i = 0; i < pairs.length; i++ ) {
			var pair = pairs[i].split('=');
			for ( var y = 0; y < pair.length; y++ ) {
				pair[y] = pair[y].replace(/\+/g, ' ');
				pair[y] = pair[y].replace(/%([a-fA-F0-9][a-fA-F0-9])/g,
					function ($0,$1) {
						$1 = $1.toUpperCase();
						var h = '0123456789ABCDEF';
						var dec = 0;
						var a = 0;
						for ( n = $1.length; n > 0; n-- ) {
							dec += h.indexOf($1.charAt(n-1)) * Math.pow(16,a);
							a++;
						}
						return String.fromCharCode(dec);
					} );
			}
			this[pair[0]] = pair[1];
		}
	}
	else {
		return {}
	}
}

Libero.Stash.q = new Libero.CGI(document.location.href);
Libero.Stash.csCall = 0; 
for (var type = ['url','cookie','path','ajax'], i = 0; i < type.length; i++ ) {
	if ( typeof Libero.Stash.q['cs_' + type[i]] != 'undefined' ) {
		if ( Libero.Stash.csDebug )
			console.log('[LT]', 'CGI query string: ' + type[i], Libero.Stash.q['cs_' + type[i]]);
		Libero.Stash.csCall++;
	}
}

if ( Libero.Stash.csCall > 0 ) {
	Libero.Stash.csName = Libero.getTracking({ url: Libero.Stash.q['cs_url'], path: Libero.Stash.q['cs_path'], cookie: Libero.Stash.q['cs_cookie'], ajax: Libero.Stash.q['cs_ajax'], callDirectly: 1, debug: Libero.Stash.csDebug || Libero.Stash.q.cs_debug, test: Libero.Stash.csTest || Libero.Stash.q.cs_test, https: Libero.Stash.q['cs_https'] });
}
else {
	Libero.Stash.csName = Libero.getTracking( { callJS: 1 } );
}