
$(function() {
	/// Monitor Add Stocks AutoComplete
	$( "#monitor_add" ).autocomplete({
		minLength: 0,
		delay: 200,
		format: "SymbolSuggest",
		appendtofield: "#monitor_add",
		source: jsonp_callback,
		select: advfn_autocomplete_select,
		search: advfn_autocomplete_search,
		open: advfn_applet_hide,
		close: advfn_applet_show
	});
});

var ADVFNDialog = {
	app_name: null,
	ret: false,
	container: null,
	prepared: false,
	user_hooks: new Array(),
	get: function(app_name)
	{
		if (app_name== null)
		{
			return;
		}
		this.app_name = app_name;

		ADVFNDialog.prepare();
		var ts = Math.round((new Date()).getTime() / 1000);
		$.ajax({
			url: "/common/js_app/"+app_name+"?t="+ts,
			dataType: "JSON",
			beforeSend: this.loading,
			success: this.load,
			error: this.error
		});
		return this.ret;
	},
	load: function(json)
	{
		if (typeof json == "undefined")
		{
			this.error();
			return;
		}

		var data = $.parseJSON(json);

		if (typeof data != "object")
		{
			this.error();
			return;
		}

		if (data.js != null)
		{
			eval(data.js);
		}
		ADVFNDialog.build();

		var options = data.data;
		ADVFNDialog.getContainer().html(data.html);

		$(".ModalBackground").html("");
		if (options.modal == false)
		{
			$(".ModalBackground").hide();
		}
		else
		{
			$(".ModalBackground").html("");
		}

		if (options.title != null)
		{
			$(".DialogTitle").html(options.title);
		}

		$(".DialogContainer").show();

		if (options.width != null)
		{
			$(".DialogContainer").width(options.width);
		}

		if (options.height != null)
		{
			$(".DialogContainer").height(options.height);
		}
		else
		{
			ADVFNDialog.autosize();
		}

		$(".DialogContainer").hAlign();
		$(".DialogContainer").vAlign();

		$("button").css("cursor", "pointer");
		$(".DialogContent button").hover(
			function() {
				$(this).css("background-color", "#3366CC");
			},
			function() {
				$(this).css("background-color", "#555");
			}
		);
		ADVFNDialog.execute_hooks("load");
	},
	error: function()
	{
		this.ret = true;
		ADVFNDialog.close();
		ADVFNDialog.execute_hooks("error");
	},
	loading: function()
	{
		$('applet').parent().css('visibility','hidden');
		$('object').parent().css('visibility','hidden');
		$(".ModalBackground").html("Loading...");
		ADVFNDialog.execute_hooks("loading");
	},
	close: function()
	{
		$('applet').parent().css('visibility','visible');
		$('object').parent().css('visibility','visible');
		$(".ModalBackground").hide();
		$(".DialogContainer").hide();
		$([document, window]).unbind('resize scroll');
		ADVFNDialog.execute_hooks("close");
	},
	prepare: function()
	{
		if (this.prepared == false)
		{
			var html = '<div class="ModalBackground"></div>';
			$("body").append(html);
			this.prepared = true;
		}
		$(".ModalBackground").show();
		$(".ModalBackground").vStretch();
		$(".ModalBackground").hStretch();
	},
	build: function()
	{
		this.buildContainers();
		$(".DialogContainer").hide();
		$(".DialogContainer").vAlign();
		$(".DialogContainer").hAlign();
		ADVFNDialog.execute_hooks("build");
	},
	buildContainers: function()
	{
		if (this.container == null)
		{
			var html = "";
			html += '<div class="DialogContainer" tabindex="-1" role="dialog">';
			html += '<div class="DialogTitlebar"><div class="DialogTitle">Dialog</div><button class="DialogCloseButton">x</button></div>';
			html += '</div>';

			$("body").append(html);
			this.container = $('<div class="DialogContent"></div>');
			$(".DialogContainer").append(this.container);
			$(".DialogCloseButton").click(ADVFNDialog.close);
			$(".ModalBackground").css({opacity:0.8});
			ADVFNDialog.execute_hooks("buildContainers");
		}

		$(window).bind('scroll', function(event) {
				$(".DialogContainer").vAlign();
				$(".DialogContainer").hAlign();
		});

		$(window).bind('resize', function(event) {
				$(".ModalBackground").vStretch();
				$(".ModalBackground").hStretch();
				$(".DialogContainer").vAlign();
				$(".DialogContainer").hAlign();
		});
	},
	getContainer: function()
	{
		if (this.container == null)
		{
			this.buildContainers();
		}
		return this.container;
	},
	autosize: function()
	{
		var height = $(".DialogContent").height()+40;
		$(".DialogContainer").height(height);
		ADVFNDialog.execute_hooks("autosize");
	},
	add_hook: function(action, func)
	{
		if (typeof this.user_hooks[action] == "undefined" || !$.isArray(this.user_hooks[action]))
		{
			this.user_hooks[action] = new Array();
		}
		this.user_hooks[action].push(func);
	},
	execute_hooks: function(action)
	{
		if (typeof this.user_hooks[action] == "undefined" || !$.isArray(this.user_hooks[action]))
		{
			return;
		}

		var call;
		$.each(this.user_hooks[action], function(key, val)
		{
			call=eval(val);
			if (typeof(call) == "function")
			{
				call();
			}
		});

	}
}

/*
var JQueryDialog = {
	app_name: null,
	ret: false,
	container: null,
	user_func: new Array(),
	get: function(app_name)
	{
		if (app_name== null)
		{
			return;
		}
		this.app_name = app_name;

		var ts = Math.round((new Date()).getTime() / 1000);
		$.ajax({
			url: "/common/js_app/"+app_name+"?t="+ts,
			dataType: "JSON",
			success: this.open,
			error: this.error
		});
		return this.ret;
	},
	open: function(json)
	{
		var data = $.parseJSON(json);
		var options = data.data;
		JQueryDialog.getContainer().html(data.html);

		if (data.js != null)
		{
			eval(data.js);
		}

		var dialog_options = new Array();
		dialog_options['height'] = 200;
		dialog_options['width'] = 400;
		dialog_options['modal'] = true;
		dialog_options['title'] = "Dialog";
		if (options.dialog != null)
		{
			$.each(data.data.dialog, function(key, value) {
				if (typeof(value) != "object")
				{
					dialog_options[key] = value;
				}
				else
				{
					dialog_options[key] = eval(value);
					$.each(dialog_options[key], function(obj_key, obj_value) {
						dialog_options[key][obj_key] = eval(obj_value);
					});
				}
			});
		}
		JQueryDialog.getContainer().dialog(dialog_options);
	},
	error: function()
	{
		this.ret = true;
	},
	getContainer: function()
	{
		if (this.container == null)
		{
			this.container = $("<div id='"+this.app_name+"_app'></div>");
		}
		return this.container;
	},
	call_func: function(func_name)
	{
		var call = get_func(func_name);
		if (typeof(call) == "function")
		{
			call();
		}
	},
	get_func: function(func_name)
	{
		var call = eval(this.user_func[func_name]);
		return call;
	},
	register_func: function(func_name, func)
	{
		this.user_func[func_name] = func;
	}
}
*/

jQuery.fn.vStretch = function() 
{
	$(this).css("height", $(document).height()+"px");
	return $(this);
}

jQuery.fn.hStretch = function() 
{
	$(this).css("width", $(document).width()+"px");
	return $(this);
}

jQuery.fn.vAlign = function() 
{
	$(this).css("left", (($(window).width() - $(this).outerWidth()) / 2) + $(window).scrollLeft() + "px");
	return $(this);
}

jQuery.fn.hAlign = function() 
{
	$(this).css("top", (($(window).height() - $(this).outerHeight()) / 2) + $(window).scrollTop() + "px");
	return $(this);
}

$(document).ready(function() 
{
	$('[role="login"]').click(function() {
		return ADVFNDialog.get('login_dialog');
	});

	if ($('[role="login_form"]').length==0)
	{
		var hash = window.location.hash;
		if (hash=="#login-error")
		{
			ADVFNDialog.get("login_dialog");
		}
	}
});

var sym = "";
var apps = new Array('chart','level2','auction','vwap','heatmap','l2basic','level2scope','spread','tradescope');

function disableEnterKey(e,textboxvalue,forcedpid)
{
     var key;
     if(window.event)
          key = window.event.keyCode;     //IE
     else
          key = e.which;     //firefox

     if(key == 13) 
     {
     	     return symbolSearch(textboxvalue,forcedpid);
     } 
     
     return true;
}

function symbolSearch(textboxvalue, forcedpid)
{
	if (forcedpid!=false) 
	{
		var url = '/p.php?pid='+forcedpid+'&symbol='+textboxvalue;
	}
	else
	{
		var url = '/p.php?pid=qkquote&symbol='+textboxvalue;
	}
	location.href=url;
	return false;
}

function setRedirectLink(type)
{
	setJavaSymbol();

	if (sym=="")
	{
		return true; /// Will just continue to follow the HREF URL
	}
	else
	{
		window.location.href = "/common/javascript/redirect?type="+type+"&symbol="+sym;
		return false;
	}
}

function setJavaLink(obj)
{
	var href = obj.href;

	setJavaSymbol()

	if (sym=="")
		return;

	if(sym!="NULL_DATA" && href.indexOf("symbol="+sym)==-1)
	{
		var new_src="";
		if(href.indexOf("symbol=")!=-1 || href.indexOf("epic=")!=-1)
		{
			var hr_arr = href.split("?");
			var src_arr = hr_arr[1].split("&");
			for(var idx=0; idx<src_arr.length; idx++)
			{
				if(src_arr[idx].indexOf("symbol=")!=-1 || src_arr[idx].indexOf("epic=")!=-1)
				{
					src_arr[idx]="symbol="+encodeURIComponent(sym);
				}
				new_src+=src_arr[idx];
				if(idx<src_arr.length-1)
					new_src+="&";
			}
			href = hr_arr[0]+"?"+new_src;
		}
		else
		{
			if(href.indexOf("?")==-1)
				href+="?symbol="+encodeURIComponent(sym);
			else
				href+="&symbol="+encodeURIComponent(sym);
		}

		window.location.href = href;
		return false;
	}
	else
		return true;
}

function setJavaSymbol()
{
	for (i=0; i<apps.length; i++)
	{
		if(document.applets[apps[i]])
			sym = document.applets[apps[i]].outsideCall("EPIC","");
	}

	if (sym=="")
		return;

	if (document.forms[0].symbol != undefined)
	{
		if(sym!="NULL_DATA")
		{
			document.forms[0].symbol.value = encodeURIComponent(sym);
		}
		else
		{
			document.forms[0].symbol.value = "";
		}
	}
}

function oc(obj)
{
	var loc = "";

	if(obj.options[obj.selectedIndex].value!=0)
	{
		loc = obj.options[obj.selectedIndex].value;

		var enabled = obj.options[obj.selectedIndex].getAttribute("symbol");
		if (enabled != "1")
		{
			window.location.href=loc;
			return;
		}

		setJavaSymbol();

		if (sym=="")
		{
			var prmstr = window.location.search.substr(1);
			var prmarr = prmstr.split ("&");
			var params = {};

			for ( var i = 0; i < prmarr.length; i++) 
			{
				var tmparr = prmarr[i].split("=");
				params[tmparr[0]] = decodeURIComponent(tmparr[1]);
			}

			if (params['symbol'])
			{
				sym = params['symbol'];
			}
		}

		if(sym!="" && sym!="NULL_DATA" && loc.indexOf("symbol="+sym)==-1 && obj.options[obj.selectedIndex].getAttribute('sym') != 'true')
		{
			sym = escape(sym);
			var new_src="";
			if(loc.indexOf("symbol=")!=-1 || loc.indexOf("epic=")!=-1)
			{
				var hr_arr = loc.split("?");
				var src_arr = hr_arr[1].split("&");
				for(var idx=0; idx<src_arr.length; idx++)
				{
					if(src_arr[idx].indexOf("symbol=")!=-1 || src_arr[idx].indexOf("epic=")!=-1)
					{
						src_arr[idx]="symbol="+sym;
					}
					new_src+=src_arr[idx];
					if(idx<src_arr.length-1)
					new_src+="&";
				}
				loc = hr_arr[0]+"?"+new_src;
			}
			else
			{
				if(loc.indexOf("?")==-1)
					loc+="?symbol="+sym;
				else
					loc+="&symbol="+sym;
			}
		}

		if(typeof openWin == 'function')
			openWin();
		
		window.location.href=loc;
		window.focus();
	}
	else
	{	     	    
		obj.selectedIndex = 0;
		window.focus();
		return false;
	}
}


//// BULLETIN BOARD VOTING AJAX/POPUP CODE
$(function() 
{
	$(".bb-vote-up").click(function() 
	{
		vote($(this), "up");
	});
	
	$(".bb-vote-down").click(function() 
	{
		vote($(this), "down");
	});

	function vote(obj, direction)
	{
		$('#bb-vote-popup').html("Loading...");
		$('#bb-vote-popup').dialog({ width:500 });

		var bb_id	= obj.attr('bb_id');
		var thread_id	= obj.attr('thread_id');
		var number	= obj.attr('number');
		var hash	= obj.attr('hash');

		var dataString = 'bb_id='+bb_id+'&thread_id='+thread_id+'&number='+number+'&hash='+hash+'&vote='+direction;

		$.ajax({
			type: "POST",
			url: "/common/bb/vote",
			data: dataString,
			success: function(text) 
			{
				$('#bb-vote-popup').html(text);
				$('#bb-vote-popup').dialog({ width:500 });
			}
		});
		return false;
	}
});
